=== debian/changelog ===
glibc (2.27-3ubuntu1) bionic; urgency=medium

  * Merge with Debian, with packaging tweaks and master updated to 2018-03-29.
  * testsuite-xfail-debian.mk: Allow tst-backtrace{4,5} and tst-cancelx{20,21}
    to fail on the 31-bit build of glibc on s390 (see upstream bug in comment)

 -- Adam Conrad <adconrad@ubuntu.com>  Mon, 16 Apr 2018 14:14:20 -0600

glibc (2.27-3) unstable; urgency=medium

  [ Samuel Thibault ]
  * hurd-i386/tg-NOFOLLOW.diff: Rename to hurd-i386/git-NOFOLLOW.diff.
  * hurd-i386/tg-NOFOLLOW-DIRECTORY.diff: Rename to
    hurd-i386/git-NOFOLLOW-DIRECTORY.diff.
  * hurd-i386/tg-_dl_random.diff: Rename to hurd-i386/git-_dl_random.diff.
  * hurd-i386/tg-exec-static.diff: Rename to hurd-i386/git-exec-static.diff.
  * hurd-i386/tg-futimens.diff: Rename to hurd-i386/git-futimens.diff.
  * hurd-i386/tg-gai_misc.diff: Rename to hurd-i386/git-gai_misc.diff.
  * hurd-i386/tg-grantpt.diff: Rename to hurd-i386/git-grantpt.diff.
  * hurd-i386/tg-gscope.diff: Rename to hurd-i386/git-gscope.diff.
  * hurd-i386/tg-libpthread-gsync-mutex.diff: Rename to
    hurd-i386/git-libpthread-gsync-mutex.diff.
  * hurd-i386/tg-libpthread-gsync-spin.diff: Rename to
    hurd-i386/git-libpthread-gsync-spin.diff.
  * hurd-i386/tg-mlockall.diff: Rename to hurd-i386/git-mlockall.diff.
  * hurd-i386/tg-pagesize.diff: Rename to hurd-i386/git-pagesize.diff.
  * hurd-i386/tg-reboot-startup.diff: Rename to
    hurd-i386/git-reboot-startup.diff.
  * hurd-i386/tg-thread-linkspace.diff: Rename to
    hurd-i386/git-thread-linkspace.diff.
  * hurd-i386/tg-timer_routines.diff: Rename to
    hurd-i386/git-timer_routines.diff.
  * hurd-i386/tg-tls-threadvar.diff: Rename to
    hurd-i386/git-tls-threadvar.diff.
  * hurd-i386/tg-tls.diff: Rename to hurd-i386/git-tls.diff.
  * hurd-i386/tg-tls_thread_leak.diff: Rename to
    hurd-i386/git-tls_thread_leak.diff.
  * hurd-i386/tg2.25-tls.diff: Rename to hurd-i386/git2.25-tls.diff.
  * hurd-i386/submitted-hurd-abilist.diff: Rename to
    hurd-i386/git-hurd-abilist.diff.
  * hurd-i386/local-libpthread-stacksize.diff: Rename to
    hurd-i386/git-libpthread-stacksize.diff.

  [ Aurelien Jarno ]
  * debian/patches/localedata/locales-fr.diff: fix conversion from <Uxxxx>
    format to ascii during the latest rebase.  Closes: bug#894078.
  * debian/patches/git-updates.diff: update from upstream stable branch:
    - Fix a missing reorder-end keyword in et_EE locale.  Closes: #894395.

 -- Aurelien Jarno <aurel32@debian.org>  Thu, 29 Mar 2018 21:47:29 +0200

glibc (2.27-2) unstable; urgency=medium

  [ Samuel Thibault ]
  * debian/patches/hurd-i386/git-UTIME.diff: New patch.
  * debian/control: Bump hurd build dep accordingly.
  * debian/libc0.3.symbols.hurd-i386: Update accordingly.

  [ Aurelien Jarno ]
  * debian/control.in/main: drop the branch from Vcs-Git.
  * debian/patches/any/local-bootstrap-headers.diff: update to install
    gnu/lib-names-$abi.h.  Closes: #892126.
  * debian/patches/git-updates.diff: update from upstream stable branch:
    - Fix FTBFS on powerpcspe.
    - debian/patches/sparc/submitted-sparc32-makecontext.diff: upstreamed.

  [ Helmut Grohne ]
  * debian/rules: drop DEB_STAGE and DEB_BUILD_PROFILE support.
  * debian/rules: disable tests for stage1.
  * debian/control.in/*: drop libc*-dev -> libc* dependencies in stage1.

 -- Aurelien Jarno <aurel32@debian.org>  Fri, 09 Mar 2018 21:48:04 +0100

glibc (2.27-1) unstable; urgency=medium

  [ Aurelien Jarno ]
  * debian/sysdeps/*.mk: install gnu/lib-names-*.h for multilib builds.
  * debian/patches/alpha/submitted-makecontext.diff: new patch to fix
    infinite backtrace within a context created by makecontext.
  * debian/patches/sparc/submitted-sparc32-makecontext.diff: new patch
    to fix infinite backtrace within a context created by makecontext.

 -- Aurelien Jarno <aurel32@debian.org>  Sat, 03 Mar 2018 11:47:56 +0100

glibc (2.27-0ubuntu2) bionic; urgency=medium

  * debian/patches/git-updates.diff: Update to 2.27 master at 2018-02-16.
  * Replace ubuntu/localedata/pt_BR-d_fmt.diff with new git-pt-fmt.diff.
  * Drop ubuntu/lddebug-scopes.diff, no longer required with gdb >= 7.12.

 -- Adam Conrad <adconrad@ubuntu.com>  Fri, 23 Feb 2018 06:01:23 -0700

glibc (2.27-0ubuntu1) bionic; urgency=medium

  * Merge with current 2.27 from Debian experimental git, remaining changes:
    - Enable libc6{,-dev}-armel on armhf and libc6{-dev}-armhf on armel.
    - Heavily mangle the way we do service restarting on major upgrades.
    - Build i386 variants as -march=i686, build amd64 with -O3, and build
      ppc64 variants (both 64-bit and 32-bit) with -O3 -fno-tree-vectorize.
    - Build generic i386 flavour with -mno-tls-direct-seg-refs for Xen.
    - Drop the libc6-xen flavour, as the above change covers Xen's needs.
    - Enable systemtap support, which is currently disabled in Debian.
    - Don't build libc-l10n, its contents get stripped for language-packs.
    - Drop libc-bin manpages Recommends to Suggests to keep it in standard.
    - Revert dropping the ldconfig wrapper, xenial still has a lot of
      packages that don't ship a trigger but instead call in postinst.
    - Use DH_COMPAT=8 for dh_strip to fix debug sections for valgrind.
    - Mangle locales package to support Ubuntu language packs seamlessly.
  * Drop debian/patches/ubuntu/localedata/bn-language.diff: Fixed upstream.
  * Allow tst-ttyname to fail on armhf/armel, as it currently fails in lxc.

 -- Adam Conrad <adconrad@ubuntu.com>  Thu, 22 Feb 2018 03:58:57 -0700

glibc (2.27-0experimental1) experimental; urgency=medium

  [ Samuel Thibault ]
  * debian/patches/hurd-i386/git-test-atexit-race-common.diff: New patch,
    fixes hurd-i386 build.

  [ Aurelien Jarno ]
  * debian/patches/any/local-ldconfig-ignore-ld.so.diff: add riscv64 program
    interpreters.
  * debian/libc6.symbols.riscv64: add riscv64 symbols file.
  * debian/patches/git-updates.diff: update from upstream stable branch.

